1 #!/bin/sh -- # no runable script, just for vi
3 # we all like colorful messages
4 CERROR
="\e[1;31m" # red
5 CWARNING
="\e[1;33m" # yellow
6 CMSG
="\e[1;32m" # green
7 CINFO
="\e[1;96m" # light blue
8 CDEBUG
="\e[1;94m" # blue
9 CNORMAL
="\e[0;39m" # default system console color
10 CDONE
="\e[1;32m" # green
11 CPASS
="\e[1;32m" # green
12 CFAIL
="\e[1;31m" # red
13 CCMD
="\e[1;35m" # pink
15 msgdie
() { echo "${CERROR}E: $1${CNORMAL}" >&2; exit 1; }
16 msgwarn
() { echo "${CWARNING}W: $1${CNORMAL}" >&2; }
17 msgmsg
() { echo "${CMSG}$1${CNORMAL}" >&2; }
18 msginfo
() { echo "${CINFO}I: $1${CNORMAL}" >&2; }
19 msgdebug
() { echo "${CDEBUG}D: $1${CNORMAL}" >&2; }
20 msgdone
() { echo "${CDONE}DONE${CNORMAL}" >&2; }
21 msgnwarn
() { echo -n "${CWARNING}W: $1${CNORMAL}" >&2; }
22 msgnmsg
() { echo -n "${CMSG}$1${CNORMAL}" >&2; }
23 msgninfo
() { echo -n "${CINFO}I: $1${CNORMAL}" >&2; }
24 msgndebug
() { echo -n "${CDEBUG}D: $1${CNORMAL}" >&2; }
25 msgtest
() { echo -n "${CINFO}$1 ${CCMD}$(echo "$2" | sed -e 's/^aptc/apt-c/' -e 's/^aptg/apt-g/' -e 's/^aptf/apt-f/')${CINFO} …${CNORMAL} " >&2; }
26 msgpass
() { echo "${CPASS}PASS${CNORMAL}" >&2; }
27 msgskip
() { echo "${CWARNING}SKIP${CNORMAL}" >&2; }
28 msgfail
() { echo "${CFAIL}FAIL${CNORMAL}" >&2; }
30 # enable / disable Debugging
31 MSGLEVEL
=${MSGLEVEL:-3}
32 if [ $MSGLEVEL -le 0 ]; then
35 if [ $MSGLEVEL -le 1 ]; then
39 if [ $MSGLEVEL -le 2 ]; then
43 if [ $MSGLEVEL -le 3 ]; then
47 if [ $MSGLEVEL -le 4 ]; then
52 if [ "$1" = "debug" -a $MSGLEVEL -le 4 ] ||
53 [ "$1" = "info" -a $MSGLEVEL -le 3 ] ||
54 [ "$1" = "msg" -a $MSGLEVEL -le 2 ] ||
55 [ "$1" = "warn" -a $MSGLEVEL -le 1 ] ||
56 [ "$1" = "die" -a $MSGLEVEL -le 0 ]; then
59 echo "${CDONE}DONE${CNORMAL}" >&2;
64 msgdebug
"Executing: ${CCMD}$*${CDEBUG} "
65 if [ -f .
/aptconfig.conf
]; then
66 APT_CONFIG
=aptconfig.conf LD_LIBRARY_PATH
=${BUILDDIRECTORY} ${BUILDDIRECTORY}/$
*
67 elif [ -f ..
/aptconfig.conf
]; then
68 APT_CONFIG
=..
/aptconfig.conf LD_LIBRARY_PATH
=${BUILDDIRECTORY} ${BUILDDIRECTORY}/$
*
70 LD_LIBRARY_PATH
=${BUILDDIRECTORY} ${BUILDDIRECTORY}/$
*
73 aptconfig
() { runapt apt
-config $
*; }
74 aptcache
() { runapt apt
-cache $
*; }
75 aptget
() { runapt apt
-get $
*; }
76 aptftparchive
() { runapt apt
-ftparchive $
*; }
77 aptkey
() { runapt apt
-key $
*; }
79 $(which dpkg) --root=${TMPWORKINGDIRECTORY}/rootdir
--force-not-root --force-bad-path --log=${TMPWORKINGDIRECTORY}/rootdir
/var
/log
/dpkg.log $
*
83 TMPWORKINGDIRECTORY
=$(mktemp -d)
84 local TESTDIR
=$(readlink -f $(dirname $0))
85 msgninfo
"Preparing environment for ${CCMD}$(basename $0)${CINFO} in ${TMPWORKINGDIRECTORY}… "
86 BUILDDIRECTORY
="${TESTDIR}/../../build/bin"
87 test -x "${BUILDDIRECTORY}/apt-get" || msgdie
"You need to build tree first"
88 local OLDWORKINGDIRECTORY
=$(pwd)
89 CURRENTTRAP
="cd /; rm -rf $TMPWORKINGDIRECTORY; cd $OLDWORKINGDIRECTORY"
90 trap "$CURRENTTRAP" 0 HUP INT QUIT ILL ABRT FPE SEGV PIPE TERM
91 cd $TMPWORKINGDIRECTORY
92 mkdir rootdir aptarchive keys
94 mkdir -p etc
/apt
/apt.conf.d etc
/apt
/sources.list.d etc
/apt
/trusted.gpg.d etc
/apt
/preferences.d
95 mkdir -p var
/cache var
/lib var
/log
96 mkdir -p var
/lib
/dpkg
/info var
/lib
/dpkg
/updates var
/lib
/dpkg
/triggers
97 local STATUSFILE
=$(echo "$(basename $0)" | sed -e 's/^test-/status-/' -e 's/^skip-/status-/')
98 if [ -f "${TESTDIR}/${STATUSFILE}" ]; then
99 cp "${TESTDIR}/${STATUSFILE}" var/lib/dpkg/status
101 touch var/lib/dpkg/status
103 touch var/lib/dpkg/available
105 ln -s ${BUILDDIRECTORY}/methods usr/lib/apt/methods
107 local PACKAGESFILE=$(echo "$(basename $0)" | sed -e 's/^test-/Packages-/' -e 's/^skip-/Packages-/')
108 if [ -f "${TESTDIR}/${PACKAGESFILE}" ]; then
109 cp "${TESTDIR}/${PACKAGESFILE}" aptarchive
/Packages
111 touch aptarchive
/Packages
113 cp $(find $TESTDIR -name '*.pub' -o -name '*.sec') keys
/
114 ln -s ${TMPWORKINGDIRECTORY}/keys
/joesixpack.pub rootdir
/etc
/apt
/trusted.gpg.d
/joesixpack.gpg
115 echo "Dir \"${TMPWORKINGDIRECTORY}/rootdir\";" > aptconfig.conf
116 echo "Debug::NoLocking \"true\";" >> aptconfig.conf
117 echo "APT::Get::Show-User-Simulation-Note \"false\";" >> aptconfig.conf
118 echo "Dir::Bin::dpkg \"fakeroot\";" >> aptconfig.conf
119 echo "DPKG::options:: \"dpkg\";" >> aptconfig.conf
120 echo "DPKG::options:: \"--root=${TMPWORKINGDIRECTORY}/rootdir\";" >> aptconfig.conf
121 echo "DPKG::options:: \"--force-not-root\";" >> aptconfig.conf
122 echo "DPKG::options:: \"--force-bad-path\";" >> aptconfig.conf
123 echo "DPKG::options:: \"--log=${TMPWORKINGDIRECTORY}/rootdir/var/log/dpkg.log\";" >> aptconfig.conf
128 configarchitecture
() {
129 local CONFFILE
=rootdir
/etc
/apt
/apt.conf.d
/01multiarch.conf
130 echo "APT::Architecture \"$1\";" > $CONFFILE
132 while [ -n "$1" ]; do
133 echo "APT::Architectures:: \"$1\";" >> $CONFFILE
138 setupsimplenativepackage
() {
142 local RELEASE
="${4:-unstable}"
143 local DEPENDENCIES
="$5"
144 local DESCRIPTION
="$6"
145 local SECTION
="${7:-others}"
147 if [ "$SECTION" = "$(echo "$SECTION" | cut -d'/' -f 2)" ]; then
150 DISTSECTION
="$(echo "$SECTION" | cut -d'/' -f 1)"
152 local BUILDDIR
=incoming
/${NAME}-${VERSION}
153 mkdir -p ${BUILDDIR}/debian
/source
155 echo "* most suckless software product ever" > FEATURES
156 test -e debian
/copyright
|| echo "Copyleft by Joe Sixpack $(date +%Y)" > debian
/copyright
157 test -e debian
/changelog
|| echo "$NAME ($VERSION) $RELEASE; urgency=low
161 -- Joe Sixpack <joe@example.org> $(date -R)" > debian
/changelog
162 test -e debian
/control
|| echo "Source: $NAME
165 Maintainer: Joe Sixpack <joe@example.org>
166 Build-Depends: debhelper (>= 7)
167 Standards-Version: 3.9.1
170 Architecture: $ARCH" > debian
/control
171 test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> debian
/control
172 if [ -z "$DESCRIPTION" ]; then
173 echo "Description: an autogenerated dummy ${NAME}=${VERSION}/${RELEASE}
174 If you find such a package installed on your system,
175 YOU did something horribly wrong! They are autogenerated
176 und used only by testcases for APT and surf no other propose…" >> debian
/control
178 echo "Description: $DESCRIPTION" >> debian
/control
180 test -e debian
/compat
|| echo "7" > debian
/compat
181 test -e debian
/source
/format
|| echo "3.0 (native)" > debian
/source
/format
182 test -e debian
/rules
|| cp /usr
/share
/doc
/debhelper
/examples
/rules.tiny debian
/rules
186 buildsimplenativepackage
() {
190 local RELEASE
="${4:-unstable}"
191 local DEPENDENCIES
="$5"
192 local DESCRIPTION
="$6"
193 local SECTION
="${7:-others}"
195 if [ "$SECTION" = "$(echo "$SECTION" | cut -d'/' -f 2)" ]; then
198 DISTSECTION
="$(echo "$SECTION" | cut -d'/' -f 1)"
200 setupsimplenativepackage
"$NAME" "$ARCH" "$VERSION" "$RELEASE" "$DEPENDENCIES" "$DESCRIPTION" "$SECTION"
201 buildpackage
"incoming/${NAME}-${VERSION}" "$RELEASE" "$DISTSECTION"
202 rm -rf "incoming/${NAME}-${VERSION}"
209 msgninfo
"Build package $(echo "$BUILDDIR" | grep -o '[^/]*$') for ${RELEASE} in ${SECTION}… "
211 if [ "$ARCH" = "all" ]; then
212 ARCH
="$(dpkg-architecture -qDEB_HOST_ARCH 2> /dev/null)"
214 local BUILT
="$(dpkg-buildpackage -uc -us -a$ARCH 2> /dev/null)"
215 local PKGS
="$( echo "$BUILT" | grep '^dpkg-deb: building package' | cut -d'/' -f 2 | sed -e "s#'\.##")"
216 local SRCS
="$( echo "$BUILT" | grep '^dpkg-source: info: building' | grep -o '[a-z0-9._+~-]*$')"
219 echo "pool/${PKG}" >> ${TMPWORKINGDIRECTORY}/incoming
/${RELEASE}.
${SECTION}.pkglist
222 echo "pool/${SRC}" >> ${TMPWORKINGDIRECTORY}/incoming
/${RELEASE}.
${SECTION}.srclist
228 if [ -d incoming
]; then
229 buildaptarchivefromincoming $
*
231 buildaptarchivefromfiles $
*
235 createaptftparchiveconfig
() {
236 local ARCHS
="$(find pool/ -name '*.deb' | grep -oE '_[a-z0-9-]+\.deb$' | sort | uniq | sed -e '/^_all.deb$/ d' -e 's#^_\([a-z0-9-]*\)\.deb$#\1#' | tr '\n' ' ')"
237 if [ -z "$ARCHS" ]; then
238 # the pool is empty, so we will operate on faked packages - let us use the configured archs
239 ARCHS
="$(aptconfig dump | grep APT::Architecture | cut -d'"' -f 2 | sed '/^$/ d' | sort | uniq | tr '\n' ' ')"
242 ArchiveDir "' >> ftparchive.conf
243 echo -n $(readlink -f .) >> ftparchive.conf
245 CacheDir "' >> ftparchive.conf
246 echo -n $(readlink -f ..) >> ftparchive.conf
248 FileListDir "' >> ftparchive.conf
249 echo -n $(readlink -f pool/) >> ftparchive.conf
253 Packages::Compress ". gzip bzip2 lzma";
254 Sources::Compress ". gzip bzip2 lzma";
255 Contents::Compress ". gzip bzip2 lzma";
259 SrcDirectory "pool/";
265 Label "apttestcases";
267 Description "repository with dummy packages";
268 Architectures "' >> ftparchive.conf
269 echo -n "$ARCHS" >> ftparchive.conf
273 };' >> ftparchive.conf
274 for DIST
in $(find ./pool/ -maxdepth 1 -name '*.pkglist' -type f | cut -d'/' -f 3 | cut -d'.' -f 1 | sort | uniq); do
275 echo -n 'tree "dists/' >> ftparchive.conf
276 echo -n "$DIST" >> ftparchive.conf
278 Architectures "' >> ftparchive.conf
279 echo -n "$ARCHS" >> ftparchive.conf
281 FileList "' >> ftparchive.conf
282 echo -n "${DIST}.\$(SECTION).pkglist" >> ftparchive.conf
284 SourceFileList "' >> ftparchive.conf
285 echo -n "${DIST}.\$(SECTION).srclist" >> ftparchive.conf
287 Sections "' >> ftparchive.conf
288 echo -n "$(find ./pool/ -maxdepth 1 -name "${DIST}.*.pkglist" -type f | cut -d'/' -f 3 | cut -d'.' -f 2 | sort | uniq | tr '\n' ' ')" >> ftparchive.conf
290 };' >> ftparchive.conf
294 buildaptftparchivedirectorystructure
() {
295 local DISTS
="$(grep -i '^tree ' ftparchive.conf | cut -d'/' -f 2 | sed -e 's#".*##')"
296 for DIST
in $DISTS; do
297 local SECTIONS
="$(grep -i -A 5 "dists/$DIST" ftparchive.conf | grep -i 'Sections' | cut -d'"' -f 2)"
298 for SECTION
in $SECTIONS; do
299 local ARCHS
="$(grep -A 5 "dists/$DIST" ftparchive.conf | grep Architectures | cut -d'"' -f 2 | sed -e 's#source##')"
300 for ARCH
in $ARCHS; do
301 mkdir -p dists
/${DIST}/${SECTION}/binary
-${ARCH}
303 mkdir -p dists
/${DIST}/${SECTION}/source
304 mkdir -p dists
/${DIST}/${SECTION}/i18n
309 buildaptarchivefromincoming
() {
310 msginfo
"Build APT archive for ${CCMD}$(basename $0)${CINFO} based on incoming packages…"
312 [ -e pool
] || ln -s ..
/incoming pool
313 [ -e ftparchive.conf
] || createaptftparchiveconfig
314 [ -e dists
] || buildaptftparchivedirectorystructure
315 msgninfo
"\tGenerate Packages, Sources and Contents files… "
316 aptftparchive
-qq generate ftparchive.conf
318 msgninfo
"\tGenerate Release files… "
319 for dir
in $(find ./dists -mindepth 1 -maxdepth 1 -type d); do
320 aptftparchive
-qq release
$dir -o APT
::FTPArchive
::Release
::Codename
="$(echo "$dir" | cut -d'/' -f 3)" | sed -e '/0 Release$/ d' > $dir/Release
# remove the self reference
326 buildaptarchivefromfiles
() {
327 msginfo
"Build APT archive for ${CCMD}$(basename $0)${CINFO} based on prebuild files…"
329 if [ -f Packages
]; then
330 msgninfo
"\tPackages file… "
331 cat Packages
| gzip > Packages.gz
332 cat Packages
| bzip2 > Packages.bz2
333 cat Packages
| lzma
> Packages.lzma
336 if [ -f Sources
]; then
337 msgninfo
"\tSources file… "
338 cat Sources
| gzip > Sources.gz
339 cat Sources
| bzip2 > Sources.bz2
340 cat Sources
| lzma
> Sources.lzma
343 msgninfo
"\tRelease file… "
344 aptftparchive
-qq release .
| sed -e '/0 Release$/ d' > Release
# remove the self reference
349 setupdistsaptarchive
() {
350 local APTARCHIVE
=$(readlink -f ./aptarchive)
351 rm -f root
/etc
/apt
/sources.list.d
/apt
-test-*-deb.list
352 rm -f root
/etc
/apt
/sources.list.d
/apt
-test-*-deb-src.list
353 for DISTS
in $(find ./aptarchive/dists/ -mindepth 1 -maxdepth 1 -type d | cut -d'/' -f 4); do
354 SECTIONS
=$(find ./aptarchive/dists/${DISTS}/ -mindepth 1 -maxdepth 1 -type d | cut -d'/' -f 5 | tr '\n' ' ')
355 msgninfo
"\tadd deb and deb-src sources.list lines for ${CCMD}${DISTS} ${SECTIONS}${CINFO}… "
356 echo "deb file://$APTARCHIVE $DISTS $SECTIONS" > rootdir
/etc
/apt
/sources.list.d
/apt
-test-${DISTS}-deb.list
357 echo "deb-src file://$APTARCHIVE $DISTS $SECTIONS" > rootdir
/etc
/apt
/sources.list.d
/apt
-test-${DISTS}-deb-src.list
362 setupflataptarchive
() {
363 local APTARCHIVE
=$(readlink -f ./aptarchive)
364 if [ -f ${APTARCHIVE}/Packages
]; then
365 msgninfo
"\tadd deb sources.list line… "
366 echo "deb file://$APTARCHIVE /" > rootdir
/etc
/apt
/sources.list.d
/apt
-test-archive-deb.list
369 rm -f rootdir
/etc
/apt
/sources.list.d
/apt
-test-archive-deb.list
371 if [ -f ${APTARCHIVE}/Sources
]; then
372 msgninfo
"\tadd deb-src sources.list line… "
373 echo "deb-src file://$APTARCHIVE /" > rootdir
/etc
/apt
/sources.list.d
/apt
-test-archive-deb-src.list
376 rm -f rootdir
/etc
/apt
/sources.list.d
/apt
-test-archive-deb-src.list
382 if [ -e aptarchive
/dists
]; then
388 msgninfo
"\tSync APT's cache with the archive… "
394 local SIGNER
="${1:-Joe Sixpack}"
395 msgninfo
"\tSign archive with $SIGNER key… "
397 for KEY
in $(find keys/ -name '*.sec'); do
398 SECKEYS
="$SECKEYS --secret-keyring $KEY"
401 for KEY
in $(find keys/ -name '*.pub'); do
402 PUBKEYS
="$PUBKEYS --keyring $KEY"
404 for RELEASE
in $(find aptarchive/ -name Release); do
405 gpg
--yes --no-default-keyring $SECKEYS $PUBKEYS --default-key "$SIGNER" -abs -o ${RELEASE}.gpg
${RELEASE}
410 changetowebserver
() {
411 if which weborf
> /dev
/null
; then
412 weborf
-xb aptarchive
/ 2>&1 > /dev
/null
&
413 CURRENTTRAP
="kill $(ps | grep weborf | sed -e 's#^[ ]*##' | cut -d' ' -f 1); $CURRENTTRAP"
414 trap "$CURRENTTRAP" 0 HUP INT QUIT ILL ABRT FPE SEGV PIPE TERM
415 local APTARCHIVE
="file://$(readlink -f ./aptarchive)"
416 for LIST
in $(find rootdir/etc/apt/sources.list.d/ -name 'apt-test-*.list'); do
417 sed -i $LIST -e "s#$APTARCHIVE#http://localhost:8080/#"
425 local DIFFTEXT
="$($(which diff) -u $* | sed -e '/^---/ d' -e '/^+++/ d' -e '/^@@/ d')"
426 if [ -n "$DIFFTEXT" ]; then
438 msgtest
"Test for correctness of file" "$FILE"
440 echo -n "" | checkdiff
$FILE - && msgpass
|| msgfail
442 echo "$*" | checkdiff
$FILE - && msgpass
|| msgfail
447 local COMPAREFILE
=$(mktemp)
448 echo "$1" > $COMPAREFILE
450 msgtest
"Test for equality of" "$*"
451 $
* 2>&1 | checkdiff
$COMPAREFILE - && msgpass
|| msgfail
456 local COMPAREFILE1
=$(mktemp)
457 local COMPAREFILE2
=$(mktemp)
458 local COMPAREAGAINST
=$(mktemp)
459 echo "$1" > $COMPAREFILE1
460 echo "$2" > $COMPAREFILE2
462 msgtest
"Test for equality OR of" "$*"
463 $
* 2>&1 1> $COMPAREAGAINST
464 (checkdiff
$COMPAREFILE1 $COMPAREAGAINST 1> /dev
/null
||
465 checkdiff
$COMPAREFILE2 $COMPAREAGAINST 1> /dev
/null
) && msgpass
||
466 ( echo "\n${CINFO}Diff against OR 1${CNORMAL}" "$(checkdiff $COMPAREFILE1 $COMPAREAGAINST)" \
467 "\n${CINFO}Diff against OR 2${CNORMAL}" "$(checkdiff $COMPAREFILE2 $COMPAREAGAINST)" &&
469 rm $COMPAREFILE1 $COMPAREFILE2 $COMPAREAGAINST
473 local VIRTUAL
="N: Can't select versions from package '$1' as it purely virtual"
476 while [ -n "$1" ]; do
478 N: Can't select versions from package '$1' as it purely virtual"
479 PACKAGE
="${PACKAGE} $1"
482 msgtest
"Test for virtual packages" "apt-cache show $PACKAGE"
484 N: No packages found"
485 local COMPAREFILE
=$(mktemp)
486 local ARCH
=$(dpkg-architecture -qDEB_HOST_ARCH_CPU)
487 eval `apt-config shell ARCH APT::Architecture`
488 echo "$VIRTUAL" | sed -e "s/:$ARCH//" -e 's/:all//' > $COMPAREFILE
489 aptcache show
-q=0 $PACKAGE 2>&1 | checkdiff
$COMPAREFILE - && msgpass
|| msgfail
494 msgtest
"Test for non-existent packages" "apt-cache show $*"
495 local SHOWPKG
="$(aptcache show $* 2>&1 | grep '^Package: ')"
496 if [ -n "$SHOWPKG" ]; then
505 testdpkginstalled
() {
506 msgtest
"Test for correctly installed package(s) with" "dpkg -l $*"
507 local PKGS
="$(dpkg -l $* | grep '^[a-z]' | grep '^[^i]' | wc -l)"
508 if [ "$PKGS" != 0 ]; then
510 dpkg
-l $
* | grep '^[a-z]'
517 testdpkgnoninstalled
() {
518 msgtest
"Test for correctly non-installed package(s) with" "dpkg -l $*"
519 local PKGS
="$(dpkg -l $* | grep '^[a-z]' | grep '^[^u]' | wc -l)"
520 if [ "$PKGS" != 0 ]; then
522 dpkg
-l $
* | grep '^[a-z]'